import type { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, PopulatedTransaction, Signer, utils } from "ethers";
import type { FunctionFragment, Result } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type { TypedEventFilter, TypedEvent, TypedListener, OnEvent, PromiseOrValue } from "./common";
export interface CID_ExternalInterface extends utils.Interface {
    functions: {
        "createDigest(uint64,bytes)": FunctionFragment;
        "encodeCID(uint64,uint64,bytes)": FunctionFragment;
    };
    getFunction(nameOrSignatureOrTopic: "createDigest" | "encodeCID"): FunctionFragment;
    encodeFunctionData(functionFragment: "createDigest", values: [PromiseOrValue<BigNumberish>, PromiseOrValue<BytesLike>]): string;
    encodeFunctionData(functionFragment: "encodeCID", values: [
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BytesLike>
    ]): string;
    decodeFunctionResult(functionFragment: "createDigest", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "encodeCID", data: BytesLike): Result;
    events: {};
}
export interface CID_External extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: CID_ExternalInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        createDigest(code: PromiseOrValue<BigNumberish>, digest: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<[BigNumber, string]>;
        encodeCID(version: PromiseOrValue<BigNumberish>, code: PromiseOrValue<BigNumberish>, multihash: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<[string]>;
    };
    createDigest(code: PromiseOrValue<BigNumberish>, digest: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<[BigNumber, string]>;
    encodeCID(version: PromiseOrValue<BigNumberish>, code: PromiseOrValue<BigNumberish>, multihash: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<string>;
    callStatic: {
        createDigest(code: PromiseOrValue<BigNumberish>, digest: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<[BigNumber, string]>;
        encodeCID(version: PromiseOrValue<BigNumberish>, code: PromiseOrValue<BigNumberish>, multihash: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<string>;
    };
    filters: {};
    estimateGas: {
        createDigest(code: PromiseOrValue<BigNumberish>, digest: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<BigNumber>;
        encodeCID(version: PromiseOrValue<BigNumberish>, code: PromiseOrValue<BigNumberish>, multihash: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<BigNumber>;
    };
    populateTransaction: {
        createDigest(code: PromiseOrValue<BigNumberish>, digest: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        encodeCID(version: PromiseOrValue<BigNumberish>, code: PromiseOrValue<BigNumberish>, multihash: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
    };
}
